
1.09
****

- Documentation updates only.

1.08
****

 - Ooops, another problem with loading (good-time, bad-times) fixed.
 - Missing tech level help page added.

1.07
****

- strcat bug in the new load code, fixed.
- mkdir -p fails on sco if the dir exists, workround done.

1.06
****

- Quite a serious 'clicking in the wrong place at the wrong time' bug fixed.
  Thanks to Timothy C. Hagman for spotting this one.
- A potential security hole closed. vga_init() is now called as close to the
  start of main() as possible.
- SCO port added.
- Gzip called with 'system' rather than through a pipe. The pipe caused
  some platforms to fail while saving.

1.05
****

- "When you are in a scene and use for example roads and then load a less
   developed scene, you can still use them, until you switch to another
   item." - Alexander Klink    Bug fixed, thanks Alex.
-  The X multi-transport code didn't actually produce working transport, it
   just 'looked right'. Thanks to Holger Dietze for the bug report and
   patch.


1.04
****

- Pix doubled X screen redraw bug, fixed.
- remove_scene() bug fix by Chris J. Kiick. Thanks.
- mini screen messy power text overwrite, fixed.
- negative interest payment bug fixed.
- prints money straight after a load.
- Modern windmill OK box added.
- Shanty placement over the edge, bug fixed. Thanks to Chris J. Kiick.
- Installed dir permissions explicitly set. Not needed for most platforms,
  but does no harm.
- Fire, cricket, health and power cover mini screens now show the areas
  that are _NOT_ within the their areas. A number of people wanted this
  change.
- An attempt at getting 24bpp X visuals working. (maybe)

1.03
****

- Endian checking added. Big endian machines couldn't load good-times etc.
- (Actually in 1.02) Multi-transport added. Activated by shift+leftclick.
  This is for X only. (SVGALib players can use the keyboard to quickly draw
  a long bit of transport.)

1.02
****

- Another screen scrolling bug fixed. Thanks to Erik Schoenfelder.
- Man page by Erik Schoenfelder. It feels good to go 'man lincity' :)
- sbut size changed to 32 (was 34).
- Various small fixes to make the compile '-Wall' clean... well nearly.
- Sparc (and some other CPUs perhaps) bug fixed. Misalignment of 32 bit
  data at 16 boundary. (Most CPUs are happy with this.)

1.01
****

- MAJOR BUG FIX. The bug that sometimes corrupted the the odd square,
  causing a SEG fault (among other things) has been FIXED. It's been there
  since the very beginning - 18 months or so. :(  Thanks to Kay Hamacher for
  that (insignificant seeming) observation, that put me on the right track.
- Pixel doubling added for X. ( xlincity -d ) Makes it 1280x960 - bigger,
  but slower.
- Mini screen 'power cover' button added.

1.00
****

- Exporters discount more as you export more. This reduces the expected
  tax revenues.
- THMO's (12. Dec 1996) transport patch added.
- Transport 'overwrite' button added.
- Mouse fixes to picedit.
- Additions to mappoint stats for some areas -  more info.
- Small fixes to residence pollution deaths and job swing.
- Sustainability detection and display added. (Experimental at this time.)
- Tech load bug (universities not woking for up to a year) fixed.

TWEAKS:
- Power (when there is no coal) used by mills increased.
- Slight change to some 'tech level loss' ratios.
- Rocket pads use more goods.
- Increased the number of jobs used by both types of industry.
- Goods made by light industry reduced slighly.


0.99
****

Setup options for money separator, default is now a comma.
Setup options for mouse sensitivity, only for SVGALib.
     - both at the top of lincity.h
Speedups to pollution and 'get/put stuff' routines. (THMO) More to follow.
Transport/water icon choosing code speedup. (THMO)
Game save dir now called ~/.Lincity rather than ~/Lincity (if you have
an old dir, it should ask you if you want to move it.

Auto mail bot (to the HoF) message, fixed.
Cost for bulldozing some things, such as power lines and solar power
stations, was a 'bit buggy'. Fixed.
Small bug in power lines fixed.
Mouse 'droppings' when loading supplied scenes (eg 'good times'), fixed.
Couldn't quit when in pause mode. Fixed.
Fixed the (X) mouse sync problem when repeating builds and running out of
money.
Fixed keyboard entry bug when asking for the type of mouse.
Fixed file and dir ownership bug for .Lin-city and .lincityrc
Fixed the 'repeat load screen' bug. (I think)

Small changes to mappoint stats. (Windmills)
Clicking with the right button on the mini-screen displays it in the main
window.
Various tweaks; waste used by farms up, recycler efficiency down, goods tax
goes up with tech level.

Added ALPHA support for FreeBSD and IRIX.

X window can no longer be resized. It wasn't very nice if you tried.
X version now has a 'confine pointer' button.
X mouse cursor changes to pirate flag when in bulldose mode.
Server side pixmaps added for some animations etc. Speeds up play in X.
Backing store enabled in X. This speeds up redraws.

You can now go from one 'right button' help screen to the next, without
clicking twice.
Right mouse button now scrolls the 'main screen' by five squares, left
button still scrolls one.
Clicking on the mini_screen now places the centre of the area where you
clicked.

Recyclers need 'real' power to work. (Not low tech windmills.)
Gamma correction for 'washed out' displays. (see README)
Fixed loading non-existent game bug.
Displays break down of port import/export values when you click on a port.
(bug fix) light industry uses more ore when powered.
Bulldoze cost displayed with right button on areas.

0.98
****

Empty residence starve bug, fixed.
Transport bug when there are no markets, fixed.
Transport deals not collecting tax bug, fixed.

Max number of markets and windmills/substations increased to 512.

sunosMakefile added. Also having to define LIBDIR twice, removed - thanks to
David Finch.

Full tips still showed a 'last month' value. Just cosmetic - it didn't
actually take any more waste.

Mail the 'hall of fame' option when you have evacuated everyone.

0.97
****

Transport bug could cause game to hang under certain conditions. Fixed.
Also if waste accumulates on transport, some will be burnt, producing
pollution.

Various other cosmetic bug fixes and edited help pages.

Slight speedup due to removal of some error checking code that's never shown
an error. (0.01% if we're lucky.)

0.96
****

Areas that could only get 'stuff' from markets can now get them from
connected transport. It tries markets first, so there shouldn't be a great
deal of difference if you play as before.

Markets now try and keep the same '% of max' as connected transport. This
makes, say, moving 'stuff' from tracks to rail through a market work as
expected. This shouldn't make the game 'play' much differently, but makes
the numbers you see a bit different, and makes things seem a little less
chaotic.

The *first time* you click on a select button, it gives you a help screen
for it. (Except tracks, as they are selected by default.)

Monuments have 50% less people building them. This means they take 50%
longer to build.

Buy and sell options in market combined. It makes no sense to split them
now (perhaps?).

'Out' and 'back' buttons added to help screens. These are in the code, not
the help pages themselves.

Roads use some goods when in use. Rail uses goods and steel when in use.
They don't decay if they can't get any (yet?).
 
Increased coal tax rate.
Coal cost more to import, and you get more for exporting it.
Steel works make less steel.
Reduced output of solar power stations slightly.
Help page cpu usage 'bug' fixed.


0.95
****

Program now untars to ./lcityxxx.tgz and default install is to
/usr/local/bin/ and /usr/local/lib/lin-city/

Dropping square boxes when dialogue boxes come up fixed, thanks Jasp.

HP-UX has no usleep(). For portability, lc_usleep() added, thanks John W.

Active area for 'area select buttons' 2 pixels wider and higher.

Some general code cleanups.

0.94
****

Some tweaks to the birthrate for the new types of residence.

Monthgraph (blue line) is prop' to the sqrt() of the peoplepool value rather
than the log().

Opening help screen changed, and you now get a little 'village' to start
with.

If you use X, you can disable the initial help screen an village with the
'-n' switch. ( ie  xlin-city -n  )

Rockets use more goods and steel.

0.93
****

Potteries will close for a short time if they can't work for some reason.
This has the effect of reducing their priority for resources when things get
tight.

The green/red arrow indicators (pbars) didn't all save and load (hence large
green arrows when you loaded a game). Fixing this means that games saved
with an earlier version won't load, sorry.

Load and save didn't work when the game was paused. They work now. (FLW)
You still can't quit when in pause mode, this might be a 'feature'. I could
'fix' it easily if people wanted it.

Oremine1 graphic showed the wrong one, fixed.

Fires were able to start before fire stations were available, this was a
bug... fixed.

Health centres are cheaper, but use more goods.

You now choose the *type* of residence you want. Also some modifications to
birth and unemployment code.

Shanty towns start appearing later (at higher tech).

Importing and exporting help to increase the tech level.

Recycler efficientcy reduced.

0.92
****

Check for save dir at startup. If this dir doesn't exist the stat button
didn't work.

More work on the stat/closing information.
Stat screen info added for fire stations, cricket grounds and health
centres.
Heavy industry - left gate onto tracks fixed.
Small bug when tech level goes above 100, fixed.

Recyclers use more waste and can burn some if they want.
Cost of universities reduced, goods used increased and jobs used reduced.
Schools use 50% more goods.
Some cosmetic fixes.
Tip capacity reduced by a third. Can't bulldoze tips.
Steel works use a little more ore.
Reduced the ore made by communes slightly.
Re-ordered the select buttons.

Farm size is now 4x4. This means you CANNOT load in scenes older than 0.92,
also, (long standing and unknown) bug with farms and jobs, fixed.

Each university needs 5 schools to supply students. Or its tech output
drops.

Colour map problem with 16 bbp X display, fixed.

0.91
****

Added the title screen to X. This has taken a while due to colour palette
problems. It's still not quite how I'd like it.

Added commune info to stat screen.

Sky added to opening title screen.


0.90
****

It sometimes exited without bringing the dialogue box up. This happened most
frequently after a save. It was nothing to do with the save, this just
brought it to the surface more often than other things.

Solaris 2.5 support - 'make solaris' added to the Makefile. This is *VERY*
experimental at the moment and is really only intended for one person to
try. If you run Solaris 2.5 please don't try this unless you know what
you're doing AND looked at what the makefile is doing.

0.89
****

Changes to the load/save stuff. This means you can't load older saved
games, sorry.
 
'stats' button and information on exit added.

OK and yes/no dialogue boxes used to eat cpu time. Fixed.

Movement of pollution speeded up slightly. Also reduced the pollution caused
by shanty towns a bit.

The pollution mini screen is automatically selected when a market has to
burn some waste. There needs to be a way to draw your attention to the
problem, before everyone moves out of the area.

Mouse droppings *really* fixed this time. (Confidence level 0.07). :)

Blocked load and save when in help. It could have caused some confusion.


0.88
****

Waste and waste tips added, and lots of small changes that go with this.

Recycling made to work with new waste. Also it comes in a lot earlier (tech
level) than it did before.

You can't load scenes saved with versions less than 0.88. This is because of
the addition of waste management. Even though you always load 'red' scenes
at your own risk, ones less than 0.88 just won't work - and it tells you so.

Pollution worked on. Lots of tweaks.

Some 'mini screens' now stick. So, for example, you can monitor pollution
without having to keep clicking on the button. Sticky ones are pollution,
ub40 and starvation. Other slight tweaks to the mini screen, also.

Yet another attempt to fix the mouse dropping a click when, for example, you
click on yes in a dialogue box. Think I've done it this time... I've said
this before though, it seems to keep creeping back. :(

Halved the output of light industry.
Ore usage bug, and stats info fixed for steel works.
Steel works use less ore.
Reduced the jobs used by universities. (400 to 300.)

Fires don't start until you can do something about them. Also the chance of
fires halved.

Rockets take more goods and steel to build.

Market and port control box 'not coming up' bug fixed.

Tech level is not a percentage any more. It still means the same thing, but
you are allowed to go over 100. (Should be interesting... who will be the
first person to get to 200? - at this point I think recyclers may have to be
renamed replicators) :) 

vga* header files were included in some files when compiling for X11. Fixed.


0.87
****

A few keyboard problems with the X port, fixed.
X port clipping bug, fixed.
X port market control window bug, fixed.
X port rogue mouse action in load/save screens fixed.

Bulldozing fires when paused now updates the screen.

Combined imports and exports into one area. Also you connect to the top left
corner rather than to 'gates' down the left hand side. Click on it twice for
a control window (as with markets). This means that there is a blank where
the import button was. It'll be filled soon.

Number of shanty towns now displayed where 'peoplepool' was.

 
0.86
****

X support added.

0.85
****

Long standing mouse wrap off the right hand side to the left hand side,
fixed. (Thanks to Laurie Harper for reminding me.)

Makefile default target, fixed. (Thanks to Laurie Harper for spotting it.)

Yes/no dialogue box sometimes dropping an extra mouse click, fixed??

Tweaks:-
Made rockets use more steel again. It's now 75% of what it was in 0.83.
Made rockets use even more goods, another 50%.


0.84
****

Major speed up after pause, slow, medium and fast buttons added.
Should be good for those with slower boxes. Fast mode is FAST on fast
boxes. :)

Santy town don't keep catching fire, well it's put out and you're not
informed.

Schmitt trigger for shanty towns coming and going. Also -ve taxes caused by
shanty towns, fixed.

Mini-screen pollution, ub40 and starve plots, updated every second, instead
of having to click on it a lot.

Communes now sell a bit of ore (again).

Communes now disappear when they can't sell any coal ore or steel.

Bug in running costs of health centers and fire stations. Fixed.

Sort of bug, windmills got power from power lines if they could, fixed.

tweaks:-
Rockets use half the amount of steel they used to, but 10 times the goods.
Potteries use 10% more ore.
Windmills produce 10% less power.
Land where there has been a fire, or shanty town, takes twice as long to
become useable. (10 years)
Parks cost 1000 rather than 10000 to demolish.
Pollution causes a few more deaths.
Reduced the sensitivity of population to goods and reduce the 'badness' of
no power. 
Light industry output halved.

0.83
****

Farms now have the same range as everything else. You don't have to put them
next to markets anymore.

Shanty Towns added. They are not nice. You can bulldose them if you want,
for what good it'll do you.  :)

Pollution a bit more mobile.

Desirability of residences effected by the size of the people pool again,
this was taken out some time ago. Time to put it back in.

Rocket crashes got the fires a bit wrong. Fixed.

Bug in power line graphics, after the move to the main loop. Fixed. Also
powerlines now go under rivers again.

Low coalmine graphic now displayed when stock>0 rather then >10%. This is to
help distinguish between a coalmine with low stocks, and one with no coal
left at all.

Fixed the 'flickering' communes when the tracks fill up with steel.

Message when you have evacuated everyone. Also rockets shown launched before
the 'launched' dialogue box comes up.

Health centres come in earlier. They cost more to run as the tech level goes
up.

Fire stations cost more to run as the tech level goes up.


0.82
****

Bug in the cost of building things as technology increased, fixed. Hopefully
this is the last of the bugs caused by reordering the select buttons.

Progress bar when loading the game added.

Bug in display of total money when changing from -ve 6 figures to +ve,
fixed.

Total money limits put in to stop wrap. -2,000,000,000 to 2,000,000,000
only. I could increase this if it's too small. I've never made, or lost,
that much money.

Put power line checking into the main time-step loop instead of in a loop of
it's own. Should speed things up a bit.

Tech level must drop 10% below the enabling value to disable a select
button. EG if a select button is enabled at 20% it will become greyed out
again if your tech level drops below 18%.

Birth rate reduced by about a third. Also health centres halve the
birthrate, rather than cut it to a 1/5th.

You have to wait 5 years before you can build on land after there has been a
fire on it. Also, fires have a random component to the time that they burn
for. This stops the ugly 'block' changes when it goes out.

Power lines no longer connect to windmills.

A few other minor fixes.


0.81
****

Load and save now tells you how to cancel. You always could, you just
weren't told about it.

After clicking on, say the coal survey, if you then used the keyboard to say
no, it threw up the dial box again. Fixed.

Added a yes/no dialogue box when you load a saved game.

Monthgraph box cleared on load.

Progress box added, Will be calling it on more things soon.


0.80
****

Mappoint stats updated once per second, real time, instead of every 10 days,
game time.

Bottom right pixel of mouse pointer took the colour value of the top left
pixel of what was under the mouse. (If you don't believe me - look closely)
Easy fix once I spotted it :)

Bug fixed in farms with between 1 and 20 jobs producing no food.

Base line food production increased.

Keyboard cursor control added. Space/enter is left button, backspace is
right button (for help). Space or return says OK in an OK box. Space, enter
or y says yes in a yes/no box - n or backspace says no.  :)

Load now allows you to load in games saved from an earlier version. You
should treat this feature with care though.

New features in picedit, ...go and play.


0.79
****

Added code to make re-ordering of select buttons easier.

Re-ordered select buttons - just a first go, not right yet.

Picedit now part of the Makefile script.  'make picedit' if you need to.
You'll need to do this if you have an old version of picedit, that means
you if you're reading this from the mailing list!

Colour palette put into a human editable file 'colour.pal' (what
imagination). Both picedit and lin-city use the same file to generate their
colour palettes.

Mouse init problem for non Microsoft mice (Found by Tristan Tarrent -
Thanks). Fixed this?? by asking for the type of mouse you have the first
time you play - stored in ~/.lincityrc

Corruption of Finance border when -ve money less than 1M - fixed.

Problems with re-ordering of select buttons, please report anything funny
happening, even if you think it's nothing to do with them.

0.78
****

Blank left where mouse was when the opening help screen is closed - fixed.

Makefile extended to support 'make clean' and 'make install'. ( I know I
should read the make documentation again - last time I read a make doc was
back in 89 :( )

Changed the name of the makefile to Makefile. Please remove the file
/usr/local/games/lincity/makefile if you untar this over an earlier release.

Fixed commune animation stall after a load.

People less mobile - don't move in and out of residences quite as 'fast'.

Birth rate reduced slightly, again.

Warning box only comes up once when you want to bulldoze monuments or
rivers. It is reset to warn again after you have selected a button other
than bulldoze.

Pbar money scaled down a bit.

Real rocket icons and animation now in place, wow... Thanks Jasp.

Oops, rocket used steel etc. when it was built but ready to launch - fixed.

Fire *spreads* a bit more easily when you have not got fire cover.

Halved the ore reserves, they weren't running out fast enough :)


0.77
****

Lots of updated graphics added including low tech windmills, thanks Jasp.

'old' windmills, rotate at half the speed.

Cheat flag added, to show you when you've cheated. Well to tell other people
really. The cheat keys should only be used for debugging.

Fly's new commune animation added, thanks.


0.76
****

Opening help screen when the game starts.

Quit during help bug fixed, by not allowing quit during help :(

Cleaned up the stats window and put a border around it.

Added a small cleanup script to make the distribution smaller.


0.75
****

More right button help stuff added.

Box around finance window.

Birth rate reduced by about 8%

Parkland pollution problem with loading an old game - solved, yes!

Quit button and y/n dialog box added.

TYPES data removed from save/load. It caused a load bug and is not even
needed.

Tracks costing nothing right at the start - fixed.

Max interest repayment now 1000000. The means you can, in theory, always
recover when you get too far in debt. Might be quit hard though!

Interest rate reduced to 1.5%, from 2.0%

0.74
****

Added money, goods, coal, ore and steel pbars.

Moved select buttons and pbars.

Fixed the mouse initialisation leaving a block on the select button bar.
(Still a couple of mouse probs to sort out - why is this such a pain?)


0.73
****

A few minor tweaks.

More help screens.

Smaller, 'pbars', and jobs pbar added.

0.72
****

Added % , . - and + to save comment.


0.71
****

When you bulldoze an ore mine, the dug stuff turns to water. Ha!

Right button brings up help screen coresponding to where the mouse is. This
only works with the select buttons at the moment.

Lin-city version number printed with the year time. (Nice to know.)

Blacksmith animation fixed.



0.70
****

Export money fixed.

Animation of fire stations. Going out for a fire. (False alarm, there
shouldn't be a real fire.)

Birth rate reduced. 1/44 to 1/48.

Coalmine 100% stock overshoot fixed.

Potteries, blacksmiths and mills now produce a bit of pollution.

Long if, else if runs changed to switch/case statements in potteries,
blacksmiths and mills. (Small speed improvement.)

Cost to buy windmills doubled.


0.69
****

A few more help pages and a proper fire station icon. I'm going to make this
3x3 and animated soon.

Updated the profilling README.

0.68
****

Save and load fixed. (Didn't remember to change it when things taken out of
structures.)

Animations times reset after load. (You had to wait until you had played as
long as you had before the save to start the animations again.

Light industry recoded. This will need some tweaking to get it right.


0.67
****

Taken some non used variables from struct TYPE.

Struct TYPE.group and .size changed to short.

Small increase in animation speed of windmills.

Shuffle mappoint from 5 to 4.

Shuffle markets from #/2+1 to #/4+1.

Slight reorder of tests in time step loop; put transport first...



0.66
****

mappoint[][].pollution moved out of structure MAPPOINT. This is because this
array is accessed linearly quite a lot and it's nicer to the cache if it's
an array. The profiling went from 6.5ms to 2.5ms for do_pollution! More will
be taken out of the array soon for the same reason.

New mouse pointer.

Some cleanups in the market code. Should execute 1 or 2 ns faster :)


0.65
****

Ports mappoint stats bug, showing no exports, fixed.

Ports now show they are connected to rivers. Icon needs a bit of work
though.

Cut down on road and rail pollution.

Added coalmine and port pollution.

Unnatural deaths cost doubled to 500.

Real-time, rather than game-time, animation added for potteries,
blacksmiths, mills, and fire.

Played with the way mills and blacksmiths work, to make them more like
potteries. This is just a code cleanup and shouldn't effect the way things
work. ( Ohhhh yehhhh!?!)

Seconds per year info added. This is to give me some timing information to
help with the optimisation.

Fires won't spread for 15 seconds, after that it's random.

Little bug in point bars (they sometimes showed a down one and a little up
one) fixed. I hope! This is the 3rd time, the other two are not documented
as they were during the development phase.

No more max population at a residence! But slightly harder to fill. The
graphic is updated every 30 seconds.


0.64
****

Fire burning wildly on tracks fixed.

-fno-strength-reduce taken out of makefile!!!  It seemed to cause an
optimisation bug!?! Isn't it supposed to be the other way round?

Month graphs for unemployment and starving scale increased. FSD is 32%

Food point-bar added.

Real-time animation for windmills added, rather than game-time.


0.63
****

Rocket launches now controllable with yes/no boxes.


0.62
****

Cleand up a few buggets in the point bars.

Fires now have more or less chance of starting, depending on what sort of
area it is.

Fixed flag compare bug in do_residence. All the tweaking in the last few
versions is meaningless, therefore more tweaking now.


0.61
****

Moved mappoint stats code to mps.cxx and mps.h. (From screen.cxx)

Point bars added to show increase/decrease of population and tech.

Monthgraph unemployment and starve graphs are now solid, to help them stand
out.

Pollution stat added to residence mps.

Fire stations cost twice as much to buy and run. They're quit cheap still.


0.60
****

Tweaked the values in do_residence to change the way people move in and out,
should mean they are slightly harder to fill up. They also like fire and
health cover. Slightly (apx.8%) higher birth rate. People like crowds less.

Dole rate up by 50%

Schools use more jobs and goods and cost more, they make more tech points
though. (I found I had to put lots of schools in.)

Cost of running windmills slightly more than doubled.

Im-ports and ex-ports now need to be connected to REAL rivers. A real river
is one that is connected to another bit of real river! I like that :)
They must connect along the *whole* right hand side.

Im-ports and ex-ports now come in at a tech level of 3.5%

Mappoint stats for markets - all values cannot go above 100% now!

Debug (cheat) keys now enabled with a #define DEBUG_KEYS

Money debug key added. 'm' now adds 1000000 quid.

New Tech level debug key - 'T' adds 1%.  't' still adds 0.1%

Fire stations have reduced range (18 now - in each direction).

Cricket areas added. They make people happier and use some jobs and goods.
Their range is 10 units in each direction.

Animated fires. They spread if you don't put them out. Fire cover stops
them spreading.

0.59
****

Oops... forgot.
Just bug fixes to 0.58 I think.

0.58
****

Monuments now produce tech points again... oops.

Fires tell you what has caught fire.

0.57
****

Fire stations added. The use a few jobs and goods. Cover is updated every
three months.

Health centres now cover an area rather than everywhere.

Small changes to population stuff, to take into account new type of
health centres.

Monuments slowly reduce their tech production to zero at 40% tech.

Mills better than blacksmiths better than potteries - More efficient use of
jobs.


0.56
****

Curvy water added.

Other costs button added to mini screen.

Interest on budget deficit added (2% per year)

Windmills cost money to run - you subsidise green power sources! (except
solar power for the time being).

Scrolling messages on opening screen.

0.55
****

Bug in ok button call up for mills etc fixed.

School mappoint stats shows 100%

Prices bug fixed (hopefully).

Tech level when potteries and blacksmiths come in swapped.

Greyed out buttons on reload bug fixed?

You can't buy certain areas when you have a budget deficit.

Budget deficit prints in red.

Starving mini screen button added.

A few more help pages added.
 
0.54
****

Communes work now, broken in last release.

Save mkdir bug fixed (I think).

Changes to when areas become available, again.

0.53
****

Opening screen added. Not finished. Need to add scrolling credits and that
sort of thing.

Schools now use goods.

Communes don't produce ore any more, they convert ore they get off tracks
into steel. They no longer produce goods or food.

Windmills don't supply light and heavy industry any more!!
  
People buy less goods if they have no power.

The people pool has no effect on how people feel about where they live; it
only had a small effect anyway.

Start selected type is track. So you don't start demolishing stuff when you
reload a game.

Loading now remembers that you have done a coal survey or not.

Tech level when buttons become active updated.  
 
0.52
****

Cost of areas is now a function of the tech level.

Universities MADE NO TECH, even though they said they did. Bug fixed. I
think the bug was introduced when I made them make more tech a few versions
ago.

Tech level erosion doubled.

Mouse auto repeat slowed down a bit.

0.51
****

New way to load and save cities. Press s to save, l to load.

All button 'up' OK dialog boxes written.

Bug fixed in mills, collected coal instead of food!

Universities use 1/5 less jobs and produce 50% more tech points.


0.50
****

People use half as many goods. They are also slightly pissed off if they
can't get power for them. The overall efect, even without power, if good
though.

Jobs reduced on a number of things.

Jobs held by markets reduced by 1/3.


0.49
****

Text drawing changed to compressed font. This won't have much efect at this
time, apart from bugs of course.


0.48
****

Massage dialog boxes added. To tell you, for example, that the tech level
has reached a high enough value to build a certain type of area.

Blacksmiths now use coal. Also a bug fixed where it was using jobs but not
making anything.

Mill mappoint stats cosmetic bug removed.

Income tax rate reduced from 10 to 8

Coal tax rate increased from 6 to 8

Potteries animated.

Tech level erosion reduced.

Schools use less jobs, but produce less tech as well, they also cost money
to run - not much though.

Monuments produce a bit more tech.
 
Universities produce more tech with less jobs and goods.

Jobs used by markets reduced.

Communes don't use jobs at the gates any more. They produce 20% more ore.

Blacksmiths, potteries and mills use less coal.

Potteries use 1/4 less ore.

Output of windmills reduced by half.

0.47
****

More help screens added.

Check dialog boxes for expensive things added. Not all things call this yet.

The first time you call a coal survey, it will cost you 1 million. It is
caught by the dialog box.

Monuments make a bit more tech.

Schools come in at the start.
 
0.46
****

More help screens added.

New helpline type; tbutton.

Monuments icon now changes as it is built.

Working population percent reduced to 45 from 50. Flexibility (swing)
increased from 10 to 15.

(debugging tool) Press t to increase tech-level by 1%.

Loosing tech points now starts at 1%. You loose 0.5% of your tech level
every month (if you don't make any more).

Help bug (try selecting help when you've got lots of windmills!) removed?

Unnatural deaths in the same residence now make people more unhappy.
Giving them power makes them even more happy than before, not giving them
power makes them a bit more unhappy.

The size of the people pool has 10 times less influence on people moving in
and out of residences.

Mouse bug. Hide_mouse, redraw mouse counts hides and counts back before a
show.

Animated blacksmith. Still needs more work on the graphics though.


0.45
****

Potteries added. They turn ore and coal into goods.

In light industry, the values for different icons have changed. 'Low' is
shown with much less output than before; it seemed to be closed when it was
churning quite well.

Monuments use some jobs to build.

Help routines added.

0.44
****

Remove people bug finally (of cource) removed. Now you can evacuate
everyone.

Monuments added. This is mainly to help start the game off. Each monument
makes 1 tech point every 10 days.

The buttons only become active when you reach a certain tech level. These
values are held in cim-city.h, for example 'GROUP_ROCKET_TECH 50' says you
must have 50% tech level to be able to click on the button. You can remove
this restriction by commenting out the line 
	'#define SELECT_BUTTONS_NEED_TECH'
near the start of cim-sity.h.

Health centres reduce the birth rate a bit, as well as doing everything they
did before.

You no longer need power for residences to permit childbirth.

Tracks now turn in to communes.

Tax from coal increased by 50%.

Export tax from coal halved, from steel, divided by 5, you can still make a
lot of money though.

Heavy industry makes less steel than before, bit of a tweak to the output
values shown by the graphics, will need more later no doubt.

Communes don't supply jobs any more, they use some at each connection point.
They do, however, produce 4 times as much ore as they used to.
 
Bulldozing costs money now. Where it tells you hoe much it costs, now tells
you how much it costs to demolish.

If you build something by mistake, you may bulldoze it and get your money
back. To do this you must not have built or bulldozed anything else. I think
I'll put a time limit in as well at some point - I'm sure you can see why.

Farms produce 3 times less output when un-powered.

Schools added. They use jobs to make tech points.

Blacksmiths added. They use steel to make goods.

Mills added. They use FOOD to make goods. These can be dangerous, it's your
job to provide enough food for the people.


0.43
****

Windmill colour added to mini screen.

Bugfix. Bulldozed markets now forget their buy/sell buttons.

Bugfix. Remove_people() (with rockets) had an = rather than == in an if.
Bah, caught again. First time for a while though :)

Power lines turn into windmills. - if you see what I mean.

Rocket stuff added to load and save.


0.42
****

Opps, lost some of the changes made, I'll see if I can remember the most
important.

Rockets added. You must launch 5 in a row successfully then you can start
taking people away 1000 per rocket. If one crashes, you must launch another
5 with no one on board.

Windmills are like substations, you can even connect power lines to them I
think, but with a windmill producing power. They need jobs to work.

This and that...


0.41
****

Rivers are NOT transport, for the time being anyway. It was far too slow.

Check_road_graphics() sets the direction flags for the new do_road()
routine.

Market control window added. Click on a market twice.

Deaths from pollution halved. This will have to do for now, I'll make it
better soon :)

New transport routines for tracks and rail, as well as roads.

0.40
****

River landscape feature added. All square though, pretty them up later.

Random numbers seeded with time(). This is to test the river code really. If
you want coal in the same place it's always been, comment the SEED_RAND
#define in cim-sity.h, or move the srand(...) line to after
coal_reserve_setup() in main.cxx ( in main() ).

Rivers are transport! The carry twice as much as tracks, but half as much as
roads. They, however, *only deal with markets*, trying to line up other
icons doesn't really work.

(Sort of bug) Mouse hidden when printing stats and drawing graphs.


Speedups
^^^^^^^^
Market icon only updated every 25 days.


0.39
****

Water added. This has been added to enable games scenarios to be set up
rather than to use in play, but you can divert a river at a cost.

Load and save working again. (Well I hope so.)

Universities hold a bigger store of goods and jobs. It makes it easier to
see which of them is in short supply.

Universities int_3 variable holds the total number of tech points this uni
has made.

Starving and unemployed percentage stats now show 10ths. ie xx.x

Power diff graph amplitude doubled.

Goods diff graph *not* divided by two anymore, still log though.

Organic farms increase output linearly to double with max tech level.

(Bug fix) Recycle centres connect to roads and rail now. Tracks always did! 

Pollution kills people. Will need some tweaking probably. It also makes
people move into the people_pool more.

Pollution mobility reduced by about 1/3. (A speedup as well.)

Farm range increased from 4 units to 6. Should it be even more?

Solar power station output with no tech level increased to what it was
before 0.33 and now increases to 3 times output with max tech level. (Very
small speedup as well.)

Jobs used to haul stuff on and off transport reduced by half.

Capital costs in yearly stats replaced by other costs, universities 50 per
'day', recycle centres also 50 per 'day' (50 per 'day' == 5000 per 'month')

All deaths, other than from old age, are counted as unnatural and cost you
250 quid. These can be from pollution or by starving for now. Figure added
to stats at bottom, under tech level, shows the unnatural deaths for the
last 'month'.

Jobs used to dig coal reduced from 1000 to 900, and jobs used to load coal
and ore into power stations and industry respectively, reduced by 10%.


Speedups.
^^^^^^^^^
Get_jobs function split into get_jobs and put_jobs.

Get_food function split into get_food and put_food.

Some ifs that weren't needed taken out of check_road|rail_graphics(), very
small speedup 'cos they're not called very often.
  

0.38
****

Profiling support added.

Light industry uses less steel, goods made per ore doubled.

Recycle goods increased five times and jobs used reduced.

Coal calorific value increased by 20%. Electricity production increased by
10%.

Background colour of graphs darkened.

Speedups:
^^^^^^^^
'Do time step' loop continues if mappoint == CST_USED.
 
In do_residence all those mappoint[x][y].population refs changed to 
(register) p.  ( Later... Bahh... -O2 does this anyway!)
 
In do_residence no more min population, <0 still caught earlier so OK to
take out, also people pool respects the old min pop. 

In do_residence 3 birth ifs made into 1 and rand() put after flagcheck.

In coal power station some transport ifs combined with use of new
FLAG_IS_TRANSPORT flag.

In do_market, transport ifs combined.

In shuffle markets number of loops cut and register int added.

In do_power_line, use FLAG_IS_TRANSPORT flag. 12 ifs now 4.

In light and heavy industry, use FLAG_IS_TRANSPORT flag.

Make file changed.



0.37
****

Diff graph put in mappoint stat window when not showing stats.

Graph windows are drawn at startup.

Max tech level doubles the output of coal power stations (linear).

P key - increases people pool by 100

D key - does a screen dump in raw rgb format (colours seem wrong though)

Unemployed and starving graph scale multiplied by two.

A speedup, perhaps. Check transport moved to 'refresh screen' rather than
'update main screen'. Probably breaks things.


0.36
****

No jobs needed for sub-stations to operate.

cim-sity.man started.


0.35
****

Mini screen coal reserve button and graphics added.

Jobs used to load coal, steel and ore onto transport reduced slightly.

Recycle centres added. They recycle used goods into ore. 10% with zero tech
level, 100% with max tech level (currently 1,000,000).

Universities have to get bigger 'clumps' of jobs. This reduces the
competition with pits and power stations.

Range of coal-mines increased from 5 to 8 units from top left corner.

Coal reserves more clumpy, it was a bit too spread out.

People less happy with pollution.

Pollution less mobile.

Mouse repeat when held down 'fixed', probably have to 'fix' it again to make
it dependent on the speed of the computer. 


0.34
****

Bug fixed to make solar power stations work again, they worked *too* well in
0.33. They had more or less infinite output (mike@emgee would have liked that).

Mouse button auto repeat.

Mini screen unemployment button and graphics added.


0.33
****

Universities use jobs and goods to do research, this adds to the tech level.

Solar power station output depends on the tech level *when built*.

Tech level 'stat' added.

More goods travel by transport.

Import costs reduced by half.

Wind blows pollution up-right (NE).

A little less pollution destroyed by normal means and a little more
destroyed by parkland.


0.32
****
Mappoint flags (powered, fed, employed) changed to bits rather than ints.
A saving of 80K (adding more flags later) in the mappoint structure
array.

Shuffle sub-stations added. Stops hammering the 'first' sub-station put in
near things.

Parks installed. These help to get rid of pollution. Use these to block your
residences from (wind born?) pollution.

Mini screen 'normal' and 'pollution' buttons and code added to show pollution
levels. 'Normal' button returns mini screen back to normal to help flipping
between the two to see where the pollution is coming from and where it's
going.

Pollution tends to move down and right (SE)

Roads, rail, light industry, heavy industry, coal mines and coal power
stations produce pollution.

0.31
****
Markets connect to roads all the way round, even though it might not look
like it yet. *Major* change in progress on the way things connect to
transport.

Coal-mines grab some jobs for next go when there is a shortage. This only
applies to *digging* the coal for now. Let's see how that goes.
 
Coal power stations grab some jobs for next go when there is a shortage.
This only applies to *generating* the electricity for now. Let's see how
that goes.

People pool goes down by 1% per month (rather than 1%+1).

People pool starts off with 100 people.
